DROP VIEW hotwire3."10_View/People/COs_View";
DROP VIEW apps.managed_mail_domain_v3;

CREATE OR REPLACE VIEW apps.managed_mail_domain_v3
 AS
 WITH all_aliases AS (
         SELECT mail_alias.alias,
            mail_alias.addresses AS target,
            mail_alias.comment,
            1 AS priority
           FROM mail_alias
        UNION
         SELECT person.crsid AS alias,
            COALESCE(person.managed_mail_domain_target, person.email_address::text) AS addresses,
            'autogenerated from db'::character varying AS comment,
            2 AS priority
           FROM person
             JOIN _physical_status_v3 ON person.id = _physical_status_v3.person_id
          WHERE (_physical_status_v3.status_id::text = 'Current'::text OR _physical_status_v3.status_id::text = 'Past'::text) AND person.crsid IS NOT NULL AND person.email_address IS NOT NULL AND btrim(COALESCE(person.managed_mail_domain_target, person.email_address::text)) <> (person.crsid::text || '@ch.cam.ac.uk'::text) AND NOT person.managed_mail_domain_optout
        UNION
         SELECT a.email_local_part AS alias,
            array_to_string(a.array_addresses, ','::text) AS addresses,
            'room alias from db'::character varying AS comment,
            3 AS priority
           FROM ( SELECT room.email_local_part,
                    ARRAY( SELECT btrim(p.email_address::text) AS btrim
                           FROM person p
                             JOIN mm_person_room mm ON p.id = mm.person_id
                             JOIN room r2 ON mm.room_id = r2.id
                             LEFT JOIN _physical_status_v3 USING (person_id)
                          WHERE r2.id = room.id AND p.email_address IS NOT NULL AND p.email_address::text ~~ '%@%'::text AND _physical_status_v3.status_id::text = 'Current'::text) AS array_addresses
                   FROM room) a
          WHERE a.array_addresses <> '{}'::text[]
        UNION
         SELECT a.alias,
            a.target,
            a.comment,
            4 AS priority
           FROM ( SELECT cabinet.email_local_part AS alias,
                    array_to_string(ARRAY( SELECT room.email_local_part::text || '@ch.cam.ac.uk'::text
                           FROM room
                             JOIN mm_cabinet_serves_room ON room.id = mm_cabinet_serves_room.room_id
                          WHERE mm_cabinet_serves_room.cabinet_id = cabinet.id), ','::text) AS target,
                    'Cabinet alias from database'::text AS comment
                   FROM cabinet) a
          WHERE a.target IS NOT NULL AND a.target <> ''::text
        UNION
         SELECT a.alias,
            array_to_string(a.array_addresses, ','::text) AS target,
            'Group computer rep alias'::character varying AS comment,
            5 AS priority
           FROM ( SELECT research_group.id,
                    research_group.name,
                    'comp-rep-'::text || regexp_replace(lower(research_group.name::text), '[^a-z]+'::text, ''::text, 'g'::text) AS alias,
                    ARRAY( SELECT btrim(p.email_address::text) AS btrim
                           FROM person p
                             LEFT JOIN _physical_status_v3 ps ON p.id = ps.person_id
                             JOIN mm_research_group_computer_rep mm ON p.id = mm.computer_rep_id
                             JOIN research_group r2 ON mm.research_group_id = r2.id
                          WHERE ps.status_id::text = 'Current'::text AND p.email_address::text ~~ '%@%'::text AND p.email_address IS NOT NULL AND r2.id = research_group.id) AS array_addresses
                   FROM research_group) a
          WHERE a.array_addresses <> '{}'::text[]
        )
 SELECT DISTINCT ON (all_aliases.alias) all_aliases.alias,
    all_aliases.target,
    all_aliases.comment
   FROM all_aliases
  ORDER BY all_aliases.alias, all_aliases.priority;

ALTER TABLE apps.managed_mail_domain_v3
    OWNER TO cen1001;

GRANT SELECT ON TABLE apps.managed_mail_domain_v3 TO ad_accounts;
GRANT ALL ON TABLE apps.managed_mail_domain_v3 TO cen1001;
GRANT SELECT ON TABLE apps.managed_mail_domain_v3 TO mailinglists;

CREATE VIEW hotwire3."10_View/People/COs_View"
 AS
 SELECT a.id,
    a.ro_person_id,
    a.image_oid,
    a.surname,
    a.first_names,
    a.title_id,
    a.name_suffix,
    a.email_address,
    a.crsid,
    a.date_of_birth,
    a.ro_post_category_id,
    a.ro_supervisor_id,
    a.research_group_id,
    a.dept_telephone_number_id,
    a.room_id,
    a.location,
    a.ro_physical_status_id,
    a.ro_estimated_leaving_date,
    a.do_not_show_on_website AS hide_person_from_website,
    a.hide_photo_from_website,
    a.hide_email AS hide_email_from_website,
    a.is_spri,
    a.managed_mail_domain_target,
    a.managed_mail_domain_optout,
    a.ro_final_managed_mail_domain_destination,
    a.ro_auto_banned_from_network,
    a.override_auto_ban,
    a.ro_network_ban_log,
    a._cssclass
   FROM ( SELECT person.id,
            person.id AS ro_person_id,
            person.image_lo AS image_oid,
            person.surname,
            person.first_names,
            person.title_id,
            person.name_suffix,
            person.email_address,
            person.crsid,
            person.date_of_birth,
            person.do_not_show_on_website,
            person.hide_photo_from_website,
            person.hide_email,
            person.is_spri,
            _latest_role.post_category_id AS ro_post_category_id,
            _latest_role.supervisor_id AS ro_supervisor_id,
            ARRAY( SELECT mm_person_research_group.research_group_id
                   FROM mm_person_research_group
                  WHERE person.id = mm_person_research_group.person_id) AS research_group_id,
            ARRAY( SELECT mm_person_dept_telephone_number.dept_telephone_number_id
                   FROM mm_person_dept_telephone_number
                  WHERE person.id = mm_person_dept_telephone_number.person_id) AS dept_telephone_number_id,
            ARRAY( SELECT mm_person_room.room_id
                   FROM mm_person_room
                  WHERE person.id = mm_person_room.person_id) AS room_id,
            person.location,
            _physical_status.status_id AS ro_physical_status_id,
            LEAST(person.leaving_date, futuremost_role.estimated_leaving_date) AS ro_estimated_leaving_date,
            managed_mail_domain_v3.target AS ro_final_managed_mail_domain_destination,
            person.managed_mail_domain_target::character varying AS managed_mail_domain_target,
            person.managed_mail_domain_optout,
            person.auto_banned_from_network AS ro_auto_banned_from_network,
            person.override_auto_ban,
            person.network_ban_log::text AS ro_network_ban_log,
                CASE
                    WHEN _physical_status.status_id::text = 'Past'::text THEN 'orange'::text
                    ELSE NULL::text
                END AS _cssclass
           FROM person
             LEFT JOIN cache._latest_role_v12 _latest_role ON person.id = _latest_role.person_id
             LEFT JOIN cache.person_futuremost_role futuremost_role ON person.id = futuremost_role.person_id
             LEFT JOIN _physical_status_v3 _physical_status ON person.id = _physical_status.person_id
             LEFT JOIN apps.managed_mail_domain_v3 ON person.crsid::text = managed_mail_domain_v3.alias::text) a
  ORDER BY a.surname, a.first_names;

ALTER TABLE hotwire3."10_View/People/COs_View"
    OWNER TO dev;

GRANT INSERT, SELECT, UPDATE, DELETE ON TABLE hotwire3."10_View/People/COs_View" TO cos;
GRANT ALL ON TABLE hotwire3."10_View/People/COs_View" TO dev;
GRANT INSERT, SELECT, UPDATE, DELETE ON TABLE hotwire3."10_View/People/COs_View" TO hr;


CREATE OR REPLACE RULE hotwire3_people_cos_view_del AS
    ON DELETE TO hotwire3."10_View/People/COs_View"
    DO INSTEAD
(DELETE FROM person
  WHERE (person.id = old.id));

CREATE TRIGGER hotwire3_people_cos_view_ins
    INSTEAD OF INSERT
    ON hotwire3."10_View/People/COs_View"
    FOR EACH ROW
    EXECUTE FUNCTION hotwire3.people_cos_view_trig();


CREATE TRIGGER hotwire3_people_cos_view_upd
    INSTEAD OF UPDATE 
    ON hotwire3."10_View/People/COs_View"
    FOR EACH ROW
    EXECUTE FUNCTION hotwire3.people_cos_view_trig();


